            BEGIN {after = 0; insh = 0; thisjoin = 1; charct = 0;
                        pages = ENVIRON["pages"];
                        section = ENVIRON["section"]
                        progname = ENVIRON["progname"]} {
                  if (($1 ~ /^\.[Ss][Hh]/ && $2 ~ /[Nn][Aa][Mm][Ee]/) ||
                     (pages == "cat" && $1 ~ /^NAME/)) {
                     if (!insh)
                        insh = 1
                     else {
                        printf "\n"
                        exit
                     }
                  } else if (insh) {
                     if ($1 ~ /^\.[Ss][HhYS]/ ||
                        (pages == "cat" &&
                           ($1 ~ /^S[yYeE]/ || $1 ~ /^DESCRIPTION/ ||
                            $1 ~ /^COMMAND/ || $1 ~ /^OVERVIEW/ ||
                            $1 ~ /^STRUCTURES/ || $1 ~ /^INTRODUCTION/))) {
                           # end insh for Synopsis, Syntax, but also for
                           # DESCRIPTION (e.g., XFree86.1x),
                           # COMMAND (e.g., xspread.1)
                           # OVERVIEW (e.g., TclCommandWriting.3)
                           # STRUCTURES (e.g., XEvent.3x)
                           # INTRODUCTION (e.g., TclX.n)
                        printf "\n"
                        exit
                     } else { # derived from Tom Christiansen perl script
                        if (!after && $0 ~ progname"-") {  # Fix old cat pages
                           sub(progname"-", progname" - ")
                        }
                        gsub(/	/, " ")          # Translate tabs to spaces
                        gsub(/  +/, " ")         # Collapse spaces
                        gsub(/ *, */, ", ")      # Fix comma spacings
                        sub(/^ /, "")            # Kill initial spaces
                        sub(/ $/, "")            # Kill trailing spaces
                        sub(/__+/, "_")          # Collapse underscores
                        if ($0 ~ /[^ ]-$/) {
                           sub(/-$/, "")         # Handle Hyphenations
                           nextjoin = 1
                        } else
                           nextjoin = 0
                        sub(/^.[IB] /, "")       # Kill bold and italics
                        sub(/^.Nm /, "")         # Kill bold
                        sub(/^.Tn /, "")         # Kill normal
                        sub(/^.Li /, "")         # Kill .Li
                        sub(/^.Dq /, "")         # Kill .Dq
                        sub(/^.Nd */, "- ")      # Convert .Nd to dash
                        gsub(/\\f[PRIB0123]/, "")   # Kill font changes
                        gsub(/\\s[-+0-9]*/, "")     # Kill size changes
                        gsub(/\\&/, "")             # Kill \&
                        gsub(/\\\((ru|ul)/, "_")    # Translate
                        gsub(/\\\((mi|hy|em)/, "-") # Translate
                        gsub(/\\\*\(../, "")        # Kill troff strings
                        sub(/^\.\\\".*/, "")        # Kill comments
                        gsub(/\\/, "")              # Kill all backslashes
                        if ($1 ~ /^\.../ || $1 == "") {
                           if (after && !needmore) {
                              printf "\n"
                              thisjoin = 1
                              charct = 0
                              after = 0
                           }
                        } else {
                           if ($0 ~ /^- /) {
                              sub("- ", " - ");
                           } else if (!thisjoin && $0 !~ /^- /) {
			      printf " "
                              charct += 1
                           }
                           thisjoin = nextjoin
                           if ($0 !~ / - / && $0 !~ / -$/ && $0 !~ /^- /) {
                              printf "%s", $0
			      charct += length
                              needmore = 0
                           } else {
                              after = 1
                              if ($0 ~ / - /) {
                                 where = match( $0 , / - /)
                              } else if ($0 ~ / -$/) {
                                 where = match( $0, / -$/)
                              } else {
                                 where = 0
                              }
                              printf "%-*s", 20-charct, sprintf( "%s (%s)",
                                    substr( $0, 0, where-1 ), section )
                              printf "%s", substr( $0, where )
                              if ($0 ~ /- *$/) {
                                 needmore = 1
                              } else {
                                 needmore = 0
                              }
                           }
                        }
                     }
                  }
            }
